package ru.dbotthepony.mc.otm.android;

import net.minecraft.nbt.CompoundTag;
import net.minecraftforge.common.util.INBTSerializable;
import ru.dbotthepony.mc.otm.capability.IAndroidCapability;

public class AndroidFeature implements INBTSerializable<CompoundTag> {
	public final AndroidFeatureType<? extends AndroidFeature> type;
	public final IAndroidCapability capability;

	public AndroidFeature(AndroidFeatureType<?> type, IAndroidCapability capability) {
		this.type = type;
		this.capability = capability;
	}

	@Override
	public boolean equals(Object obj) {
		if (super.equals(obj))
			return true;

		if (obj instanceof AndroidFeature feature)
			return feature.type.equals(type);

		return false;
	}

	public void invalidateNetwork() {
		// when player forgets everything
	}

	public void attachFinish() {
		// override
	}

	@Override
	public int hashCode() {
		return type.hashCode();
	}

	public void tickClient() {

	}

	public void tickServer() {

	}

	public void serializeNBT(CompoundTag tag) {

	}

	@Override
	public CompoundTag serializeNBT() {
		var tag = new CompoundTag();
		serializeNBT(tag);
		return tag;
	}

	@Override
	public void deserializeNBT(CompoundTag tag) {

	}
}
